unit DevControl;

interface
uses Windows;
const
    DLL_NAME = 'dmdll.dll';

type
TagErrorCode=(
              DM_ERR_OK ,
              DM_ERR_PARA,
              DM_ERR_NOAUTH,
              DM_ERR_AUTHFAIL ,
              DM_ERR_SOCKET,
              DM_ERR_MEM ,
              DM_ERR_TIMEOUT ,
              DM_ERR_ARG,
              DM_ERR_MATCH,
              DM_ERR_MAX);

type
ParaTypes=(
    BAUDRATE  ,                    // '
    DATABITS ,                     // 'ڴλ
    STOPBITS  ,                    // 'ֹͣλ
    PARITY   ,                     // 'УλżУ
    FLOWCONTROL  ,                 // 'ô
    FIFO      ,                    // 'ڽշͻֽ
    ENABLEPACKING  ,               // 'Ƿְ
    IDLEGAPTIME  ,                 // 'ѡ񴮿ķǻʱ
    MATCH2BYTESEQUENCE ,           // 'ʹݰƥβֽ
    SENDFRAMEONLY ,                // 'ݰʱǷֻݷȥǰְֽ
    SENDTRAILINGBYTES,            // 'ѡNone/One/Twoְƥֽ
    INPUTWITHACTIVECONNECT ,       // 'ѡǵģΪͻӽʱģ鵽ʹõ뻺
    OUTPUTWITHACTIVECONNECT ,      // 'ѡǵģΪͻӽʱģ鵽ʹõ
    INPUTWITHPASSIVECONNECT ,      // 'ѡǵģΪӽʱ絽ģʹõ뻺
    OUTPUTWITHPASSIVECONNECT,      // 'ѡǵģΪӽʱ絽ģʹõ
    INPUTATTIMEOFDISCONNECT,       // 'ѡǵ豸֮ӶϿʱ뻺
    OUTPUTATTIMEOFDISCONNECT ,     // 'ѡǵ豸֮ӶϿʱ
    IPCONFIGURATION ,             //  'ֶ/ԶȡIP
    AUTONEGOTIATE ,                // 'ѡTrueģ齫ԶЭټȫ˫or˫Ĺʽ
    MACADDRESS ,                   // 'ģָһMACַͬһڵĲͬģҪвͬMACַ
    SPEED ,                        // 'ѡ10M or 100M
    Duplex ,                       // 'ѡĹģʽȫ˫ or ˫
    NETPROTOCOL ,                  // 'ѡģͨѶʹõЭ
    ACCEPTINCOMING  ,              // 'ǷUDP
    ARPCACHETIMEOUT,               // 'ARP峬ʱʱ
    TCPKEEPACTIVE ,                // '
    CPUPERFORMANCEMODE,            // 'CPUʵģʽṩģʽûѡHigh or Regular
    HTTPSERVERPORT ,               // '趨ģHTTP WEB˿
    MTUSIZE    ,                   // 'MTUֵ
    RETRYCOUNTER ,                 // 'ģΪͻγHostlistĴ
    IPADDRESS  ,                   // 'IPַ
    FIRMWARE  ,                    // '
    UPTIME  ,                      // '
    SERIALNO  ,                    // '
    RETRYTIMEOUT  ,                // 'ģΪͻγHostlistʱʱ䵥λΪ
    HOSTLIST1_IP ,
    HOSTLIST1_PORT   ,
    HOSTLIST2_IP,
    HOSTLIST2_PORT ,
    HOSTLIST3_IP ,
    HOSTLIST3_PORT ,
    HOSTLIST4_IP ,
    HOSTLIST4_PORT ,
    HOSTLIST5_IP,
    HOSTLIST5_PORT ,
    HOSTLIST6_IP ,
    HOSTLIST6_PORT,
    HOSTLIST7_IP ,
    HOSTLIST7_PORT ,
    HOSTLIST8_IP ,
    HOSTLIST8_PORT ,
    HOSTLIST9_IP ,
    HOSTLIST9_PORT ,
    HOSTLIST10_IP ,
    HOSTLIST10_PORT  ,
    HOSTLIST11_IP ,
    HOSTLIST11_PORT ,
    HOSTLIST12_IP  ,
    HOSTLIST12_PORT,
    FIRSTMATCHBYTE ,              // '趨ƥݰֽڸʽΪ16
    LASTMATCHBYTE ,               // '趨ƥݰβֽڸʽΪ16
    DATAGRAMTYPE  ,                // 'ѡݰͷʽ
    DEVICEADDRESSTABLE1_BEGINIP ,   //'
    UDPLOCALPORT  ,                // 'UDP鲥ض˿ں
    UDPREMOTEPORT  ,               // 'UDPԶ˿ں
    UDPNETSEGMENT  ,               // 'UDP鲥εַ
    DEVICEADDRESSTABLE2_BEGINIP ,
    DEVICEADDRESSTABLE2_PORT  ,
    DEVICEADDRESSTABLE2_ENDIP  ,
    DEVICEADDRESSTABLE3_BEGINIP ,
    DEVICEADDRESSTABLE3_PORT  ,
    DEVICEADDRESSTABLE3_ENDIP  ,
    DEVICEADDRESSTABLE4_BEGINIP  ,
    DEVICEADDRESSTABLE4_PORT  ,
    DEVICEADDRESSTABLE4_ENDIP ,
    UDPUNICASTLOCALPORT ,          // 'ض˿
    ACCEPTIONINCOMING ,            // 'ѡYesģΪµѡNoģΪͻ
    ACTIVECONNECT ,                // 'ü
    STARTCHARACTER  ,             //  '趨ʼַʽΪ16
    ONDSRDROP ,                   //  'ѡYesģ鵽DSRɸߵƽΪ͵ƽʱģTCPȫϿ
    HARDDISCONNECT ,             //   'ģϿʱЭ̣ fin-ack ʽ ֱӶϿ
    CHECKEOT ,                    //  'ѡYesģ鵽дEOT(Ctr-D)ַʱϿTCP
    INACTIVITYTIMEOUT_M ,
    INACTIVITYTIMEOUT_S ,
    LOCALPORT  ,                  //  '趨ģͨѶTCPض˿
    REMOTEHOST ,                  //  '趨TCPģͨѶԶIPַ
    REMOTEPORT  ,                //  '趨TCPģͨѶԶ˿
    DNSQUERYPERIOD  ,             //  'DNSЧʱ
    DEVICEADDRESSTABLE1_ENDIP,
    DEVICEADDRESSTABLE1_PORT ,
    CONNECTRESPONSE,              //  'Ӧģʽ
    TERMINALNAME ,                //  'ն
    USEHOSTLIST ,                 //  'Ƿʹб
    EMAILADDRESS ,                //  'EMAIL͵ַ
    EMAILUSERNAME ,               //  'EMAILû
    EMAILPASSWORD ,               //  'EMAIL
    EMAILINPUTTRIGGERMESSAGE ,    //  'EMAIL
    EMAILADDRESS1,               //   'ʼĵַ1
    EMAILADDRESS2 ,              //   'ʼĵַ2
    EMAILADDRESS3 ,               //  'ʼĵַ3
    POP3DOMAINNAME ,
    SMTPDOMAINNAME ,               // 'SMTP
    POP3PORT ,
    SMTPPORT  ,                   //  'SMTP˿ں
    COLDSTART ,                   //  '
    DCDCHANGED ,                  //  'modemDCD״̬仯ʱʼ
    DSRCHANGED ,                  //  '
    WARMSTART ,                   //  'ʼ
    AUTHENTICATIONFAILURE ,       //  'ûɵ¼ʧܴʼ
    IPADDRESSCHANGED ,             // 'ģ鵱ǰIPַʼ
    ENABLESERIALTRIGGERINPUT,      // 'ѡTrueģ鴮ڽյ緢ضַʱʼ
    SERIALCHANNEL  ,               // 'ѡ񴥷ʼĴں
    SERIALDATASIZE ,               // 'ѡ񴮿ڴʼַ
    SERIALMATCHDATA1 ,             // 'ַ1趨ʼضַʽΪ16
    SERIALMATCHDATA2  ,            // 'ַ2趨ʼضַʽΪ16
    EMAILTRIGGERSUBJECT ,          // 'ʼ
    PRIORITY  ,                    // 'ʼȼ
    INPUTPRIORITY,
    INPUTMINNOTIFICATIONINTERVAL ,
    MINNOTIFICATIONINTERVAL  ,
    RENOTIFICATIONINTERVAL  ,
    NEWUSERPSW  ,
    BOOTP   ,                     //  'ǷЭIPַ
    DHCP   ,                      //  'ǷDHCPЭIPַ
    AUTOIP  ,                    //   'ǷAUTO IPЭIPַ
    DHCPHOSTNAME  ,              //   'DHCP
    subnet  ,                    //   '
    DEFAULTGATEWAY ,            //    '
    DeviceName  ,               //    '豸
    TIMEZONE ,                  //    'ʱ
    LOCALTIME_YEAR  ,
    LOCALTIME_MONTH   ,
    LOCALTIME_DAY ,
    LOCALTIME_HOUR  ,
    LOCALTIME_MINUTE  ,
    LOCALTIME_SECOND ,
    TIMESERVER ,                  //  'ʱ
    WEBCONSOLE ,                 //   'Webʹ
    TELNETCONSOLE  ,             //   'Telnetʹ
    PASSWORDCHANGED ,            //   '봥ʼ
    SERIALPORTOPTIONS ,          //   'ʹ
    PREFERREDDNSSERVER ,         //   'ѡDNS
    ALTERNATEDNSSERVER  ,        //   'DNS
    SERIALMATCHDATA3  ,          //   'ַ3趨ʼضַʽΪ16
    INPUT1  ,                   //   'I/O 1 ʼI/O 1ƽ
    INPUT2 ,                    //    'I/O 2 ʼI/O 1ƽ
    IO1  ,                      //    'Input/Output 1
    IO2  ,                     //     'Input/Output 2
    IO1TYPE  ,
    IO2TYPE ,
    IO1STATE  ,
    IO2STATE  ,
    SERIALPORTPROTOCOL ,
    FIRMWAREID ,
    PPPOEUSERNAME  ,             //   'PPPoE˺
    PPPOEPASSWORD  ,             //   'PPPoE
    PPPOEWORKMODE   ,            //   'PPPoEģʽ
    PPPOEMAXREDIALTIMES ,         //  'ز
    PPPOEREDIALINTERVAL ,         //  'PPPoEز
    PPPOEIDLETIME  ,             //   'PPPoEҶǰʱ
    PPPOESTATUS   ,               //  'PPPoE״̬
    PPPOEIP   ,                   //  'PPPoEǰȡIPַ
    PPPOEGATEWAY  ,                // 'PPPoEǰȡ
    PPPOEDNS1 ,                   //  'PPPoEǰȡDNS1
    PPPOEDNS2 ,                    // 'ʾPPPoEǰȡDNS2
    ENABLEBACKUPLINK );
    Function DM_Init(searchCB:PLongInt;
                     data:LongInt ): LongInt;
                       stdcall;external DLL_NAME ;

    Function DM_SearchDevice(devIP:DWORD;
                     timeout:LongInt ): LongInt;
                       stdcall;external DLL_NAME ;

    Function DM_DeInit(): LongInt;
                       stdcall;external DLL_NAME ;

    Function DM_GetDeviceInfo(devhandle:LongInt;
                              var devIP:DWORD;
                              mac:PChar;
                              devName:PChar): LongInt;
                       stdcall;external DLL_NAME ;

     Function DM_AuthLogin(devhandle:LongInt;
                              name:PChar;
                              pwd:PChar;
                              timeout:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function DM_FreeDevice(devhandle:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function paralistCreate(devhandle:LongInt): LongInt;
                       stdcall;external DLL_NAME ;

     Function paralistDestroy(list:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function paralist_addnode(list:LongInt;
                              chanNo:LongInt;
                              paraType:ParaTypes;
                              valueLen:LongInt;
                              var value:Byte): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function paralist_getnode(list:LongInt;
                              chanNo:LongInt;
                              paraType:ParaTypes;
                              var valueLen:LongInt;
                              var value:Byte): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function DM_GetPara(devhandle:LongInt;
                              list:LongInt;
                              timeout:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;
     Function DM_SetPara(devhandle:LongInt;
                              list:LongInt;
                              timeout:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function DM_ResetDevice(devhandle:LongInt;
                              timeout:LongInt): TagErrorCode;
                       stdcall;external DLL_NAME ;

     Function DM_LogOutDevice(devhandle:LongInt;
                              timeout:LongInt): TagErrorCode;                     
                       stdcall;external DLL_NAME ;


   type
     TSearchCallback=procedure( dev:LongInt;
                               data:LongInt); stdcall;
     procedure SearchCallback ( dev:LongInt;
                               data:LongInt); stdcall;
  //

implementation
uses  frmUHFReader289demomain;
    procedure SearchCallback ( dev:LongInt;
                               data:LongInt); stdcall;
    var   //
      devIP:DWORD;
      mac:array[0..30]of Char;
      devName:array[0..30]of Char;
    begin
      devIP:=0;
      mac:='';
      DM_GetDeviceInfo (dev, devIP, mac, devName);
      frmUHFReader289main.SearchCallback1(devIP, mac, devName, dev ) ;
    end;

end.
